﻿using Borepin.Service.BFFH;
using Prism.Mvvm;
using Prism.Navigation;
using System;
using System.Collections.ObjectModel;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;

namespace Borepin.PageModel.AddServerProcess
{
    public class HostSelectPageModel : BindableBase
    {
        private readonly INavigationService _NavigationService;
        private readonly IBFFHService _BFFHService;

        public HostSelectPageModel(INavigationService navigationService, IBFFHService bffhService)
        {
            _NavigationService = navigationService;
            _BFFHService = bffhService;

            UseHostCommand = new Command(UseHostCommandExecuted);
            DetectHostCommand = new Command(DetectHostCommandExecuted);

            Task.Run(LoadData);
        }

        private void LoadData()
        {

        }

        private string _Host;
        public string Host
        {
            get => _Host;
            set => SetProperty(ref _Host, value);
        }

        private ObservableCollection<string> _KnownHost_List;
        public ObservableCollection<string> KnownHost_List
        {
            get => _KnownHost_List;
            set => SetProperty(ref _KnownHost_List, value);
        }

        private ICommand _UseHostCommand;
        public ICommand UseHostCommand
        {
            get => _UseHostCommand;
            set => SetProperty(ref _UseHostCommand, value);
        }

        private async void UseHostCommandExecuted()
        {
            UriBuilder builder = new UriBuilder(Host);
            if(builder.Port == 80)
            {
                builder.Port = 59661;
            }

            Model.Connection connection = new Model.Connection()
            {
                Address = builder.Uri
            };

            await _BFFHService.Connect(connection);

            INavigationResult result = await _NavigationService.NavigateAsync("AddServerProcess_LoginChoosePage");
            if(!result.Success)
            {
                System.Diagnostics.Debugger.Break();
            }
        }

        private ICommand _DetectHostCommand;
        public ICommand DetectHostCommand
        {
            get => _DetectHostCommand;
            set => SetProperty(ref _DetectHostCommand, value);
        }

        private void DetectHostCommandExecuted()
        {
            // Use Demo Host
            Host = "127.0.0.1:59661";
        }
    }
}
