﻿using Borepin.Base;
using Prism.Commands;
using Prism.Navigation;
using System.Threading.Tasks;
using System.Windows.Input;

namespace Borepin.PageModel.SetUpProcess
{
    public class WelcomePageModel : PageModelBase
    {
        #region Constructors
        public WelcomePageModel(INavigationService navigationService) : base(navigationService)
        {
            NextCommand = new DelegateCommand<object>(NextCommandCommandExecuted);
        }
        #endregion

        #region Data
        public override Task LoadData()
        {
            return Task.CompletedTask;
        }
        #endregion

        #region Commands
        private ICommand _NextCommand;
        public ICommand NextCommand
        {
            get => _NextCommand;
            set => SetProperty(ref _NextCommand, value);
        }
        private async void NextCommandCommandExecuted(object obj)
        {
            INavigationResult result = await _NavigationService.NavigateAsync("SetUpProcess_ScanPage");
            if (!result.Success)
            {
                System.Diagnostics.Debugger.Break();
            }
        }
        #endregion

        #region INavigationAware
        public override void OnNavigatedFrom(INavigationParameters parameters)
        {
            
        }

        public override void OnNavigatedTo(INavigationParameters parameters)
        {
            
        }
        #endregion
    }
}
